// Set defaults if variables are empty
if( promoslider_options.timeDelay.length == 0 ){ promoslider_options.timeDelay = 6; }
if( promoslider_options.noAutoAdvance.length == 0 ){ promoslider_options.noAutoAdvance = false; }

// Assign variable for setInterval so we can reset it as needed
var psInterval;

// Function returns a random number between 1 and n
function rand(n){return(Math.floor(Math.random()*n+1));}

jQuery(document).ready(function(){
 
  // Disable title HTML attribute for slider images
  jQuery('.promo_slider img').removeAttr('title');

  // Get all instances of promo_slider on page
  var sliders = jQuery('div.promo_slider');
  
  jQuery.each(sliders, function(){

	// Define current slider
	var current_slider = this;
	
	// Get all panels
    var panels = jQuery('.panel', current_slider);
	
	// Get total count of panels
    var total_items = panels.length;
	
	// Generate numbers for nav
	var navNums = '';
	var i = 1;
	jQuery.each(panels, function(index, object){
	  newNum = '<span title="' + jQuery(object).attr('value') + '">' + jQuery(object).attr('value') + '</span>';
	  if(i != total_items){newNum = newNum + ' | ';}
	  navNums = navNums + newNum;
	  i++;
	});
	
	// Insert numbers into nav
	jQuery('.slider_selections', current_slider).html(navNums);
	
	// Slide navigation
	var slideNav = jQuery('.slider_selections span', current_slider);
	jQuery.each(slideNav, function(index, object){
	  jQuery(object).click(function(){
									
		clearInterval(psInterval);
		
		// Get number for current and new panel
		var current_value = jQuery('div.current', current_slider).attr('value');
		var new_value = jQuery(object).attr('title');
		
		// Assign variables for ease of use
		var cur_item = jQuery('div.current', current_slider);
		var new_item = jQuery('.panel-' + new_value, current_slider);
		var cur_span = jQuery('.slider_selections span[title=' + current_value + ']', current_slider);
		var new_span = jQuery('.slider_selections span[title=' + new_value + ']', current_slider);
		
		// Add / Remove classes
		cur_item.removeClass('current');
		new_item.addClass('current');
		cur_span.removeClass('current');
		new_span.addClass('current');
		
		// Fade in / out
		cur_item.fadeOut('fast', function(){
		  new_item.fadeIn('fast');
		});
		
		// If more than one item exists
		if(total_items > 1){
		  // Automatically advance slides only if autoAdvance is enabled
		  if( promoslider_options.noAutoAdvance == false ){
			// Cycle through panels
			psInterval = setInterval(function(){
			  moveForward(current_slider, total_items);
			}, (promoslider_options.timeDelay * 1000) );
		  }
		}
		else {
			jQuery('.promo_slider_nav', this).hide();
		}
		
	  });
	});
	
	// Set number for first panel
	var start_value = rand(total_items);
	
	// Hide all panels
	jQuery('.panel', this).hide();
	
	// Show initial panel
	jQuery('.panel-' + start_value, this).show();
	
	// Set panel class to 'current'
	jQuery('.panel-' + start_value, this).addClass('current');
	
	// Set span class to 'current'
	jQuery('.slider_selections span[title=' + start_value + ']', this).addClass('current');
	
	// Create click functions for navigational divs
	jQuery('.move_forward', this).click(function(){ moveForward(current_slider, total_items); });
	jQuery('.move_backward', this).click(function(){ moveBackward(current_slider, total_items); });
	
	// If more than one item exists
	if(total_items > 1){
	  // Automatically advance slides only if autoAdvance is enabled
	  if( promoslider_options.noAutoAdvance == false ){
		// Cycle through panels
		psInterval = setInterval(function(){
		  moveForward(current_slider, total_items);
		}, (promoslider_options.timeDelay * 1000) );
	  }
	}
	else {
		jQuery('.promo_slider_nav', this).hide();
	}
	
  });
  
  // Move forward
  function moveForward(current_slider, total_items){
	  
	  clearInterval(psInterval);
	  
	  // Find number of current panel
	  var current_value = Number(jQuery('.current', current_slider).attr('value'));

	  // Update number to new panel
	  var new_value = current_value + 1;
	  if(new_value > total_items){new_value = 1;}
	  
	  // Assign variables for ease of use
	  var cur_item = jQuery('.panel-' + current_value, current_slider);
	  var new_item = jQuery('.panel-' + new_value, current_slider);
	  var cur_span = jQuery('.slider_selections span[title=' + current_value + ']', current_slider);
	  var new_span = jQuery('.slider_selections span[title=' + new_value + ']', current_slider);
	  
	  // Add / Remove classes
	  cur_item.removeClass('current');
	  new_item.addClass('current');
	  cur_span.removeClass('current');
	  new_span.addClass('current');
	  
	  // Fade in / out
	  cur_item.fadeOut('fast', function(){
		new_item.fadeIn('fast');
	  });
	  
	  // If more than one item exists
		if(total_items > 1){
		  // Automatically advance slides only if autoAdvance is enabled
		  if( promoslider_options.noAutoAdvance == false ){
			// Cycle through panels
			psInterval = setInterval(function(){
			  moveForward(current_slider, total_items);
			}, (promoslider_options.timeDelay * 1000) );
		  }
		}
		else {
			jQuery('.promo_slider_nav', this).hide();
		}

  }
  
  // Move backward
  function moveBackward(current_slider, total_items){	  
	  
	  clearInterval(psInterval);
	  
	  // Find number of current panel
	  var current_value = Number(jQuery('.current', current_slider).attr('value'));
	  
	  // Update number to new panel
	  var new_value = current_value - 1;
	  if(new_value == 0){new_value = total_items;}
	  
	  // Assign variables for ease of use
	  var cur_item = jQuery('.panel-' + current_value, current_slider);
	  var new_item = jQuery('.panel-' + new_value, current_slider);
	  var cur_span = jQuery('.slider_selections span[title=' + current_value + ']', current_slider);
	  var new_span = jQuery('.slider_selections span[title=' + new_value + ']', current_slider);
	  
	  // Add / Remove classes
	  cur_item.removeClass('current');
	  new_item.addClass('current');
	  cur_span.removeClass('current');
	  new_span.addClass('current');
	  
	  // Fade in / out
	  cur_item.fadeOut('fast', function(){
		new_item.fadeIn('fast');
	  });
	  
	  // If more than one item exists
	  if(total_items > 1){
		// Automatically advance slides only if autoAdvance is enabled
		if( promoslider_options.noAutoAdvance == false ){
		  // Cycle through panels
		  psInterval = setInterval(function(){
			moveForward(current_slider, total_items);
		  }, (promoslider_options.timeDelay * 1000) );
		}
	  }
	  else {
		  jQuery('.promo_slider_nav', this).hide();
	  }
	  
  }

});